<?php

	# 		Marine - U.K.
	# 		Namespace:		marineUK
	#		Meteotemplate Block

	# 		v1.0 - Jun 22, 2017
	# 			- initial release
	
		
	// load theme
	$designTheme = json_decode(file_get_contents("../../css/theme.txt"),true);
	$theme = $designTheme['theme'];
	
	include("../../../config.php");
	include("../../../css/design.php");
	include("../../../scripts/functions.php");
	
	$languageRaw = file_get_contents($baseURL."lang/gb.php");
	$language['gb'] = json_decode($languageRaw,true);
	$languageRaw = file_get_contents($baseURL."lang/".$lang.".php");
	$language[$lang] = json_decode($languageRaw,true);

	//error_reporting(E_ALL);

	createCacheDir();

	if(file_exists("settings.php")){
		include("settings.php");
	}
	else{
		echo "Please go to your admin section and go through the settings for this block first.";
		die();
	}	

	if(file_exists("cache/data.txt")){ 
		if (time()-filemtime("cache/data.txt") > 60 * 0) {
			unlink("cache/data.txt");
		}
	}
	if(file_exists("cache/data.txt")){
		$data = json_decode(file_get_contents("cache/data.txt"),true);		
	}
	else {
		$shipURL = "http://datapoint.metoffice.gov.uk/public/data/val/wxmarineobs/all/json/sitelist?key=".$metOfficeAPI;
		$shipData = json_decode(loadContent($shipURL,8),true);

		for($i=0;$i<count($shipData['Locations']['Location']);$i++){
			$stations[$shipData['Locations']['Location'][$i]['id']] = $shipData['Locations']['Location'][$i];
		}

		$dataURL = "http://datapoint.metoffice.gov.uk/public/data/val/wxmarineobs/all/json/all?res=hourly&type=ShipSynops&key=".$metOfficeAPI;
		$dataRaw = json_decode(str_replace("$","time",loadContent($dataURL,8)),true);

		for($i=0;$i<count($dataRaw['SiteRep']['DV']['Location']);$i++){
			$thisData = $dataRaw['SiteRep']['DV']['Location'][$i];
			$id = $thisData['i'];
			foreach($thisData['Period'] as $dayData){
				$midnight = strtotime($dayData['value']);
				if(isset($dayData['Rep']['T'])){
					$time = $midnight + ($dayData['Rep']['time']*60);
					$values[$time] = $dayData['Rep']['T'];
				}
				else{
					for($j=0;$j<count($dayData['Rep']);$j++){
						$hourData = $dayData['Rep'][$j];
						$time = $midnight + ($hourData['time']*60);
						//$values[$time]['W'] = addData("W",$hourData); // weather type
						$values[$time]['V'] = addData("V",$hourData); // visibility [nmi]
						$values[$time]['T'] = addData("T",$hourData); // temperature [C]
						$values[$time]['S'] = addData("S",$hourData); // wind speed [kt]
						$values[$time]['P'] = addData("P",$hourData); // pressure [hPa]
						//$values[$time]['D'] = addData("D",$hourData); // wind direction
						$values[$time]['Pt'] = addData("Pt",$hourData); // pressure tendency [Pa/s]
						$values[$time]['Dp'] = addData("Dp",$hourData); // dew point [C]
						$values[$time]['H'] = addData("H",$hourData); // screen relative humidity [%]
						$values[$time]['St'] = addData("St",$hourData); // sea temperature [C]
						$values[$time]['Wh'] = addData("Wh",$hourData); // wave height [m]
						$values[$time]['Wp'] = addData("Wp",$hourData); // wave period [s]
					}
				}
			}
			$data[$id] = array(
				"station" => $stations[$id],
				"values" => $values
			);
		}
		file_put_contents("cache/data.txt",json_encode($data));
	}

	function addData($var,$dataArr){
		if(isset($dataArr[$var])){
			return $dataArr[$var];
		}
		else{
			return 'null';
		}
	}

	if($theme=="light"){
		$graphColor = $color_schemes[$design2]["900"];
	}
	else{
		$graphColor = "fff";
	}

	//print_r($data);
	
?>
	<style>
		
	</style>
	<table style="width:90%;margin: 0 auto">
		<tr>
			<td style="text-align:left;width:25%">
				<img src="<?php echo $pageURL.$path?>imgs/<?php echo $flagIconShape?>/big/gb.png" style="width:100%;max-width:60px">
			</td>
			<td style="text-align:center">
				<h2><?php echo lang('marine data','c')?></h2>
			</td>
			<td style="text-align:right;width:25%">
				<span class="fa fa-ship" style="font-size: 2.5em;opacity:0.7"></span>
			</td>
		</tr>
	</table>
	<table style="width:98%;margin:0 auto">
		<tr>
			<td style="width:50%">
				<select class="button2" id="marineUKShipSelector">
					<option value="" selected>Select ship</option>
					<?php 
						foreach($data as $id=>$dataSet){
							if(!isset($firstStation)){
								$firstStation = $id;
							}
					?>
							<option value="<?php echo $dataSet['station']['id']?>"><?php echo $dataSet['station']['name'].", ".$dataSet['station']['obsRegion']?></option>
					<?php
						}
					?>
				</select>
			</td>
			<td>
				<div id="marineUKParamSelectorDiv"></div>
			</td>
		</tr>
	</table>
	
	<div id="marineUKDiv" style="width:98%;height:400px;margin:0 auto"></div>
	<div id="marineUKShipInfo" style="width:90%;margin:0 auto;text-align:left;padding-left:10px"></div>
	<div style="width:90%;margin:0 auto;font-size:0.8em;font-variant:small-caps;text-align:center">
		<?php echo lang('data source','c')?>: MetOffice
	</div>
	<script>
		Highcharts.setOptions({
			lang: {
				months: ['<?php echo lang('january','c')?>', '<?php echo lang('february','c')?>', '<?php echo lang('march','c')?>', '<?php echo lang('april','c')?>', '<?php echo lang('may','c')?>', '<?php echo lang('june','c')?>', '<?php echo lang('july','c')?>', '<?php echo lang('august','c')?>', '<?php echo lang('september','c')?>', '<?php echo lang('october','c')?>', '<?php echo lang('november','c')?>', '<?php echo lang('december','c')?>'],
				shortMonths: ['<?php echo lang('janAbbr','c')?>', '<?php echo lang('febAbbr','c')?>', '<?php echo lang('marAbbr','c')?>', '<?php echo lang('aprAbbr','c')?>', '<?php echo lang('mayAbbr','c')?>', '<?php echo lang('junAbbr','c')?>', '<?php echo lang('julAbbr','c')?>', '<?php echo lang('augAbbr','c')?>', '<?php echo lang('sepAbbr','c')?>', '<?php echo lang('octAbbr','c')?>', '<?php echo lang('novAbbr','c')?>', '<?php echo lang('decAbbr','c')?>'],
				weekdays: ['<?php echo lang('sundayAbbr','c')?>', '<?php echo lang('mondayAbbr','c')?>', '<?php echo lang('tuesdayAbbr','c')?>', '<?php echo lang('wednesdayAbbr','c')?>', '<?php echo lang('thursdayAbbr','c')?>', '<?php echo lang('fridayAbbr','c')?>', '<?php echo lang('saturdayAbbr','c')?>'],
				resetZoom: ['<?php echo lang('default zoom','c')?>']
			}		
		});
	</script>
	<?php 
		$graphHueColor = getColorHue("#".$color_schemes[$design2]["900"],"hex");
	?>
	<script>
		Highcharts.createElement('link', {
			href: 'http://fonts.googleapis.com/css?family=PT+Sans:400,700&subset=latin,cyrillic-ext,latin-ext',
			rel: 'stylesheet',
			type: 'text/css'
		}, null, document.getElementsByTagName('head')[0]);
		// Apply the theme
		Highcharts.theme = {
			chart: {
				backgroundColor: null,
				color: "#<?php echo $color_schemes[$design]['font900']?>",
				style: {
					fontFamily: "'<?php echo $designFont?> Narrow', sans-serif"
				}
			},
			title: {
				style: {
					color: "#<?php echo $graphColor?>",
					textTransform: 'uppercase',
					fontSize: '20px'
				}
			},
			subtitle: {
				style: {
					color: '#E0E0E3',
					textTransform: 'uppercase'
				}
			},
			xAxis: {
				gridLineColor: '#<?php echo $graphColor?>',
				labels: {
					style: {
						color: '#<?php echo $graphColor?>',
					}
				},
				lineColor: '#<?php echo $graphColor?>',
				minorGridLineColor: '#<?php echo $graphColor?>',
				tickColor: '#<?php echo $graphColor?>',
				title: {
					style: {
						color: '#<?php echo $graphColor?>',
					}
				}
			},
			yAxis: {
				gridLineColor: '#<?php echo $graphColor?>',
				gridLineWidth: 0,
				labels: {
					style: {
						color: '#<?php echo $graphColor?>',
					}
				},
				lineColor: '#<?php echo $graphColor?>',
				minorGridLineColor: '#<?php echo $graphColor?>',
				tickColor: '#<?php echo $graphColor?>',
				tickWidth: 1,
				title: {
					style: {
						color: '#<?php echo $graphColor?>',
					}
				}
			},
			tooltip: {
				backgroundColor: '#<?php echo $color_schemes[$design2]['900']?>',
				style: {
					color: '#<?php echo $color_schemes[$design2]['font900']?>'
				}
			},
			plotOptions: {
				series: {
					dataLabels: {
						color: '#<?php echo $color_schemes[$design2]['900']?>'
					},
					marker: {
						lineColor: '#333'
					}
				}
			},
			legend: {
				itemStyle: {
					color: '#<?php echo $graphColor?>'
				},
				itemHoverStyle: {
					color: '#<?php echo $color_schemes[$design2]['500']?>'
				},
				itemHiddenStyle: {
					color: '#777777'
				},
			},
			credits: {
				style: {
					color: '#666'
				},
				text: '<?php echo $pageName." @ Meteotemplate"?>',
				href: '<?php echo $pageURL.$path?>'
			},
			labels: {
				style: {
					color: '#707073'
				}
			},
		};
		Highcharts.setOptions(Highcharts.theme);
		options = 	{
			chart: {
				zoomType: 'x'
			},
			title: {
				text: "",
				useHTML: true
			},
			subtitle: {
				text: 'Last 24h'
			},
			yAxis:[
				{
					title: {
						text: 'm'
					}
				}
			],
			legend: {
				enabled: false
			},
			tooltip: {
				enabled: false
			},
			xAxis:{
				tickInterval: 1,
				
			},
			/*plotOptions: {
				series: {
					pointStart: 1961,
					marker: {
						enabled: false
					}
				},
			},*/
			series: [
				{
					type: "spline",
					data: [],
				}
			]
		};
		Highcharts.chart('marineUKDiv', options);
		function updateMarineUK(id, parameter){
			/*region = $("#climateFIRegion").val();
			period = $("#climateFIPeriod").val();
			parameter = $("#climateFIParameter").val();*/
			$.ajax({
				url : "homepage/blocks/marineUK/loadData.php?id=" + id + "&parameter=" + parameter,
				dataType : 'json',
				success : function (json) {
					graph = $("#marineUKDiv").highcharts();
					graph.update({
						title: {
							text: json['name']
						},
						yAxis:[
							{
								title: {
									text: json['units']
								}
							}
						],
						series: [
							{
								type: "spline",
								name: json['name'],
								data: json['data'],
								color: "<?php echo $theme=='dark' ? '#fff' : '#000'?>"
							}
						],
					});
				}
			});
		}
		$("#marineUKShipSelector").change(function(){
			ship = $(this).val();
			if(ship==""){
				return false;
			}
			$("#marineUKParamSelectorDiv").load("homepage/blocks/marineUK/loadParams.php?ship=" + ship);
			$("#marineUKShipInfo").load("homepage/blocks/marineUK/shipInfo.php?ship=" + ship);
		})	
	</script>
	
